%% @(#) ENIB/LI2 (c) - oRis - Version 2.3
%%--------------------------------------------------------------------------%%
%% file        : init.pl                                                    %%
%% description : prolog code for oRis / SWI-Prolog interface                %%
%% author(s)   : P. Reignier                                                %%
%% copyright   : Laboratoire d'Informatique Industrielle (LI2)              %%
%%               Ecole Nationale d'Ingenieurs de Brest (ENIB)               %%
%%               CP 15 - 29608 Brest Cedex - FRANCE                         %%
%%               Tel: (33) 02.98.05.66.31 , Fax: (33) 02.98.05.66.29        %%
%%               e-mail: li2@enib.fr                                        %%
%%--------------------------------------------------------------------------%%
%% Copyright (c) 1996-2000                                                  %%
%% Laboratoire d'Informatique Industrielle (LI2)                            %%
%% Ecole Nationale d'Ingenieurs de Brest (ENIB)                             %%
%%                                                                          %%
%% Permission to use, copy, modify, distribute and sell this software       %%
%% and its documentation for any purpose is hereby granted without fee,     %%
%% provided that the above copyright notice appear in all copies and        %%
%% that both that copyright notice and this permission notice appear        %%
%% in supporting documentation.                                             %%
%% ENIB/LI2 makes no representations about the suitability of this          %%
%% software for any purpose.                                                %%
%% It is provided "as is" without express or implied warranty.              %%
%%--------------------------------------------------------------------------%%

:- op(200,xfx,--->).  % operateur d'appel de methode a la mode oRis


% on transforme un appel de methode en un appel au predicat 
% predefini orisCall

Agent ---> Methode :- getParams(Methode, MethodeName, Params, Result), 
	prolog2Oris(Agent, MethodeName, Params, Result).


getParams(Methode, MethodeName, Params, Result) :-
	Methode =.. [MethodeName, Result|Params]. 

% appel Prolog a partir d'oRis. Le predicat lit la commande 
% a executer et appelle l'interpreteur dessus (la lecture est
% redirigee depuis oRis : elle est effectuee depuis une chaine de caractere)

oris2Prolog :- read(X),  % lecture de l'ordre Prolog fournit par oRis
	seen,            % fermeture de la chaine de communucation prolog-oRis
	call(X).         % execution de la requete


% lien entre prolog et les comportements

seekFuzzyLing(Pred,Terme,Set) :-
	Pred =.. PredBase,
	conc(PredBase, [Terme,Set],L),
	G =.. L,
	call(G).

getFuzzyIn(_,_,0.0).  % echec de l'appel => valeur lue = 0 par defaut


genDataOut(Pred,Var, Val) :-
	Pred =.. PredBase, 
	conc(PredBase, [Var,Val],L),
	G =.. L,
	call(G), !.

getDataIn(Pred,Var,Val) :-
	Pred =.. PredBase, 
	conc(PredBase, [Var,Val],L),
	G =.. L,
	call(G), !.

% utilitaires

conc([],L,L).
conc([A|B],L,[A|R]) :- conc(B,L,R).

debug(X) :- tell('debugPl'), writeq(X), told.

inverse([],[]).
inverse([T|Q],L) :- inverse(Q,A), conc(A,[T], L).


% supprime de la base le predicat P a N arguments

clearPredicat(P,N) :- P =.. Q, createListe(L,N), 
	conc(Q,L,Y), X =.. Y, retract(X), fail.
clearPredicat(_).

createListe([],0).
createListe([_|Q],N) :- N>0, J is N-1, createListe(Q,J).

% lien avec le moteur flou

:- consult(fuzzy).

